<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Time_sheet_table extends Base_table {

	function __construct()
	{
        parent::__construct(array('tbl'=>'time_sheet', 'tbl_key'=>'time_sheet_id'));
        $this->last_task = array();
	}
	
	public function formatdata(&$data) 
	{
		/*if (!empty($data['task_type_id'])) {
			$this->CI->db->select('is_billable');
			$this->CI->db->from('project_task_types');
			$this->CI->db->where(array('task_type_id' => $data['task_type_id'], 'project_id'  => $data['project_id']));
			$query = $this->CI->db->get();
			$row = $query->row_array();
			$data['is_billable'] = ($row)?$row['is_billable']:$data['is_billable'];
		}*/
		
		if (!empty($data[$this->tbl_key]) && $data['hours'] && isset($data['estimated_hours']))
		{
			unset($data['estimated_hours']);
		}

        return true;
    }
    
	public function save($data, $params= array())
	{
		$data['is_billable'] = !empty($data['is_billable'])?$data['is_billable']:0;
		$data['tbl_key']			= 'time_sheet_id';
		$data['tbl']				= 'time_sheet';
		
		$values	= $data;

		$unapproved	= true;
		if (!empty($data['approval_status']) && $data['approval_status'] == 'A')
		{
			$unapproved	= false;
		}

		if (!empty($data[$this->tbl_key]) && !empty($data['project_task_id']))
		{
			$this->CI->db->select('hours as actual_hours,project_task_id AS actual_task_id');
			$this->CI->db->from('time_sheet');
			$this->CI->db->where(array('time_sheet_id' => $data['time_sheet_id'], 'entity_id' => $this->entity_id));
			$row = $this->CI->db->get()->row_array();
			if ($row) {
				$data = array_merge($data,$row);
			}
		}

		if ($time_sheet_id = parent::save($values , $params)) 
		{
			$result	= $this->detail_store($time_sheet_id, $data);
			if ($result)
			{
				$result	= is_array($result) ? $result : array($result);
				$result['entry_date'] = $data['entry_date'];	
			}
			
			// update hours in project table
			$params = array('project_id' => $data['project_id'], 'hours' => $data['hours'], 'task_type_id' => $data['task_type_id'], 'is_billable' => $data['is_billable']);
			if (!empty($data['actual_hours']))
			{
				$params['actual_hours'] = $data['actual_hours'];
			}
			if (!empty($data['user_id']))
			{
				$params['user_id'] = $data['user_id'];
			}

			$params['hours'] = $hours = !empty($data['actual_hours'])?($data['hours'] - $data['actual_hours']): $data['hours'];
			$this->update_actual_value($params, $unapproved);
				
			// update worked hours when task id get changed
			if (!empty($data['actual_task_id'])) {
				$this->CI->db->where(array('task_id' =>$data['actual_task_id'], 'entity_id' => $this->entity_id));
				$this->CI->db->set('worked_hours', 'worked_hours-'.$data['actual_hours'], FALSE);
				if ($row) {					
					$this->CI->db->set('actual_start_date', 'CASE WHEN `actual_start_date` IS NULL THEN "'.$this->cur_time.'"  ELSE `actual_start_date` END', FALSE);
				}
				$this->CI->db->update('project_task');

				$hours = $data['hours'];
			}

			// updated task worked hours
			if (!empty($data['project_task_id']))
			{
					
					$this->CI->db->select('project_task_id');
					$this->CI->db->from('time_sheet');
					$this->CI->db->where(array('project_task_id' => $data['project_task_id'], 'entity_id' => $this->entity_id));
					$this->CI->db->where('(hours > 0 OR is_progress = 1)');
					$row = $this->CI->db->get()->row();					

					$this->CI->db->where(array('task_id' =>$data['project_task_id'], 'entity_id' => $this->entity_id));
					$this->CI->db->set('worked_hours', 'worked_hours+'.$hours, FALSE);
					if ($row) {
						// update actual start time						
						$this->CI->db->set('actual_start_date', 'CASE WHEN `actual_start_date` IS NULL THEN "'.$this->cur_time.'"  ELSE `actual_start_date` END', FALSE);
					}
					$this->CI->db->update('project_task');

			}
			
			/*if (!empty($values[$this->tbl_key]))
			{
				activity_log('HN',$time_sheet_id, $this->CI->ot_user->get('first_name').' '.$this->CI->ot_user->get('last_name').'  updated timesheet ');
			} else {
				activity_log('HU',$time_sheet_id, $this->CI->ot_user->get('first_name').' '.$this->CI->ot_user->get('last_name').' posted new timesheet ');
			}*/
			
			$result['project_task_id'] 			= $values['project_task_id'];
			$result['last_updated_date']		= strtotime($values['last_updated_date'])*1000;
			
			return $result;
		}
		
		return false;
	}
	
	public function update_actual_value($data, $is_unapproved=true)
	{
		$this->CI->db->select('budget_type');
		$this->CI->db->from('project');
		$this->CI->db->where(array('project_id' => $data['project_id'], 'entity_id' => $this->entity_id));
		$row = $this->CI->db->get()->row();
		$actual_value = ($data['hours'])?$data['hours']:0;
		
		/*if (!empty($data['actual_hours']))
		{
			$actual_value = ($actual_value>=0)?$actual_value - $data['actual_hours']:$actual_value;
		}*/
		$hours = $actual_value;

		$bug_typ = '';
		//echo $row->budget_type;exit;

		// check member exists in project
		$user_row = array();
		$user_id = $this->user_id;

		if (!empty($data['user_id'])) {
			if(!is_member())
				$user_id = $data['user_id'];
			unset($data['user_id']);
		}

		if (is_admin() && empty($data[$this->tbl_key]))
		{
			$this->CI->db->select('hourly_rate');
			$this->CI->db->from('project_users');
			$this->CI->db->where(array('project_id' => $data['project_id'], 'user_id' => $user_id));
			$user_row = $this->CI->db->get()->row_array();
	
			// get user hourly rate if user not mapped with admin
			if (!$user_row)
			{
				$this->CI->db->select('first_name, last_name, user_role, hourly_rate');
				$this->CI->db->from('entity_users');
				$this->CI->db->where(array('entity_id' => $this->entity_id , 'user_id' => $user_id));
				$user_row = $this->CI->db->get()->row_array();
				
				$user_row['project_id']	= $data['project_id'];
				$user_row['user_id'] 	= $user_id;
				$user_row['project_user_id'] = 0;
				
				$this->CI->load->library('project_users_table');
				if (!$pro_u_id = $this->CI->project_users_table->save($user_row))
				{
					return false;
				}
				$this->CI->load->model('project');
				$this->CI->project->reset_members_count($data['project_id']);
			}
		}

// 		if (!$is_unapproved)
// 		{
			$this->CI->db->set('actual_hours', 'actual_hours+'.$hours, FALSE);
			$this->CI->db->where(array('entity_id' => $this->entity_id, 'project_id' => $data['project_id'], 'task_type_id' => $data['task_type_id']));
			$this->CI->db->update('project_task_types');
			
			$this->CI->db->set('actual_hours', 'actual_hours+'.$hours, FALSE);
			$this->CI->db->where(array('entity_id' => $this->entity_id, 'project_id' => $data['project_id'], 'user_id' => $user_id));
			$this->CI->db->update('project_users');
			// update actual value based on project type			
			$this->CI->load->library('project_table');
			$this->CI->project_table->update_actual_value(array('project_id' => $data['project_id']));
			// update uninvoice hours
			$this->CI->db->set('uninvoiced_hours', 'uninvoiced_hours+'.$hours, FALSE);
			$this->CI->db->where(array('project_id' => $data['project_id'], 'entity_id' => $this->CI->ot_app->get('entity_id')));
			$this->CI->db->update('project');
// 		}

		return true;
	}
	
	function is_valid_timings ($data)
	{
		if (isset($data['details']) && $data['details'])
		{
			// check any active timesheet before entry date
			$active_res	= $this->CI->timesheets->get_active_details('t.time_sheet_id, t.entry_date', array());
			if ($active_res && (strtotime($data['entry_date'])>strtotime($active_res['entry_date'])))
			{
				$this->CI->response->error('TIME_SHEET_RUNNING_OLD_DAYS');
				return false;
			}	
			$k = $hours	= 0;
			$times = $details = array();
			
			foreach ($data['details'] as $row)
			{
				if (!empty($row) && $row['from_time'])
				{
					$row['time_sheet_id']	= !empty($data['time_sheet_id']) ? $data['time_sheet_id'] : 0;
					$row['from_time']		= time_in_24_hour_format($row['from_time']);
					$row['to_time']			= $row['to_time']?time_in_24_hour_format($row['to_time']):'';
					if ($row['is_progress']!=1 && strtotime($row['from_time']) > strtotime($row['to_time'])) return false;
					$details[] = $row;
					$times[] = strtotime($row['from_time']);
				}
			}
			
			asort($times);
			$order_keys = array_keys($times);
			$n = -1;
			$user_id = (!is_member() && !empty($data['user_id']))?$data['user_id']:$this->user_id;
			foreach($times as $key=>$val)
			{
					$val = $details[$key];
					// check from time less than last detail end date
					if (isset($details[$n]) && strtotime($details[$n]['to_time'])>strtotime($val['from_time']))
					{
						$this->CI->response->error('FROM_TIME_GREATER');
						return false;
					}
					$this->CI->db->select('count(pr.project_id) as pr_count');
					$this->CI->db->from('project AS pr');
					$this->CI->db->join('time_sheet AS t', 'pr.project_id=t.project_id', 'INNER');
					$this->CI->db->join('time_sheet_detail AS td', 't.time_sheet_id=td.time_sheet_id', 'INNER');
					$where = '';
					if (!empty($val['time_sheet_id']))
					{
							$where = 't.time_sheet_id !='. $val['time_sheet_id'].' AND ';
					}
					$where.= "pr.entity_id = ". $this->entity_id." AND ".
							"t.user_id = ". $user_id." AND ".
							"t.entry_date = '".date("Y-m-d", strtotime($data['entry_date']))."' AND ";
					
					if ($val['to_time']) {
							$where.="((from_time < '".$val['to_time']."' AND (to_time>'".$val['from_time']."' OR td.is_progress= 1)) OR ".
							"(from_time = '".$val['from_time']."' AND to_time = '".$val['to_time']."'))";
					} else {
						$where.="(to_time>'".$val['from_time']."' OR td.is_progress= 1)";
					}
					
					$this->CI->db->where($where);		
					$query = $this->CI->db->get();

					$result = $query->row();
					if ($result->pr_count)
					{
						$this->CI->response->error('TIME_CONFLICT');
						return false;
					}
					$n = $key;
			}
		}
		return true;
	}
	
	function detail_store($time_sheet_id, $data)
	{
		$result	= array('time_sheet_id' => $time_sheet_id);

		if (isset($data['details']) && $data['details'])
		{
			$hours	= 0;
			foreach ($data['details'] as $row)
			{
				if (!empty($row))
				{
					$row['tbl_key']			= 'time_sheet_detail_id';
					$row['tbl']				= 'time_sheet_detail';
					$row['time_sheet_id']	= $time_sheet_id;
					$diff_hours = 0;
					if($row['to_time']) {
						$row['from_time']		= time_in_24_hour_format($row['from_time']);
						$row['to_time']			= time_in_24_hour_format($row['to_time']);
						//calculate hours
						$diff_hours		= strtotime($row['to_time']) - strtotime($row['from_time']);
					} else {
						$row['from_time']		= time_in_24_hour_format($row['from_time'], true);
						unset($row['to_time']);
					}
					$row['hours'] = $diff_hours>0?($diff_hours / 3600):0;

					$row['user_id']			= $data['user_id'];
					$row['entity_id']		= $this->entity_id;
					$params = array();

					if (!empty($row[$row['tbl_key']]))
					{
						// conditions used for when update data
						$params['where'] = array('time_sheet_id' => $time_sheet_id);
					}

					if ($detail_id = parent::save($row, $params))
					{
						$result['detail_ids'][] = $detail_id;
						$hours+=$diff_hours;
					}
				}
			}
			
			// $hours = (!$this->CI->ot_app->get('time_stamp_req') && !empty($data['hours']))?$data['hours']:$hours/3600;
			$hours = (!empty($data['hours']))?$data['hours']:$hours/3600;
			$this->CI->db->where(array('time_sheet_id' => $time_sheet_id, 'is_progress' => 0));
			$this->CI->db->update('time_sheet', array('hours' => $hours));	
			$result['hours']	= $hours;
		}
		return $result;
	}
}
/* end of Task_type_table.php */
