<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/projects/mod.projects_pm.php');

class Projects_pmf extends Projects_pm
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function search_members($term="")
	{
		/*if (empty($term))
		{
			return false;
		}*/

		$this->db->select('e.user_id, e.first_name, e.user_role, e.user_image, e.hourly_rate');
		$this->db->from('entity_users as e');
		$this->db->where('e.entity_id =', $this->ot_app->get('entity_id'));
		if (!empty($term))
		$this->db->like('e.first_name', $term);
		$this->db->order_by('e.first_name');
		$query	= $this->db->get();

		return $query->result_array();
	}
	
	//	return projects list query
	public function projects_list_query($select, $options = array())
	{
		$first_word = 'FROM';
		$second_word = 'INNER JOIN';
		$options['union_query']	= 1;
		$query = parent::projects_list_query($select, $options);
		$query_pm = $this->db->last_query();
		
		preg_match('/'.preg_quote($first_word).'(.*?)'.preg_quote($second_word).'/is', $query_pm, $match);
		if(!empty($match))
			$query_pm = str_replace($match[1], str_replace(array("(",")"), array("",""), $match[1]), $query_pm);
		
		$this->db->select($select.", pru.user_role", false);
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.project_id=pru.project_id', 'INNER');
		$this->db->join('client as cl', 'pr.client_id = cl.client_id', 'INNER');
		
		$where = array();
		unset($options['filters']['pru.user_role !=']);
		
		$options['filters']['pru.user_role'] = 'F';
		if (!empty($options['filters']))
		{
			foreach($options['filters'] as $key=>$val) {
				if (is_array($val))
					$this->db->where_in($key,$val);
				else
					$where[$key] = $val;
			}
		}

		$where['pr.entity_id']	= $this->ot_app->get('entity_id');
		if (empty($where['pru.user_id']))
		{
			$where['pru.user_id']	= $this->ot_user->get('user_id');
		}

		$this->db->where($where);
		
		$order_by 			= !empty($options['order_by']) ? $options['order_by'] : 'pr.project_name';
		$order_by_direction = !empty($options['order_by_direction']) ? $options['order_by_direction'] : 'asc';

		// $this->db->order_by($order_by, $order_by_direction);
		
		$from = !empty($options['from'])?$options['from']:0;
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}
		
		$this->db->get();
		$query_pmf = $this->db->last_query();
		
		preg_match('/'.preg_quote($first_word).'(.*?)'.preg_quote($second_word).'/is', $query_pmf, $match);
		if(!empty($match))
			$query_pmf = str_replace($match[1], str_replace(array("(",")"), array("",""), $match[1]), $query_pmf);
		
		return "SELECT * from ($query_pm UNION $query_pmf)  pr ORDER BY $order_by";
	}

	// return projects in as array of standard array indexes
	public function get_projects($select = '', $options = array())
	{
//		if (empty($options))
//		{
//			$options	= array_merge($options, $this->options);
//		}
		$select = ($select)?$select:'pr.project_id, cl.client_id, concat(pr.project_code, pr.project_name) AS project_name, pr.project_code, pr.budget_value, pr.actual_value, pr.budget_type, pr.members_count, pr.created_date,pr.is_active, pr.bg_color, pr.created_by';
		$options['filters']['pru.user_role !='] = 'F';
		
		$query =  $this->db->query($this->projects_list_query($select, $options));

		return $query->result_array();
	}
	
	
	public function team_members($roles, $all=false)
	{
		$this->db->select('e.user_id, e.first_name, e.last_name, e.user_role, e.user_image, e.hourly_rate');
		$this->db->from('entity_users as e');
		$this->db->where('e.entity_id =', $this->ot_app->get('entity_id'));
		if (!$all)
		{
			$this->db->where('e.is_active', '1');
		}
		// $this->db->where_in('user_role', array_keys($roles));
		$this->db->order_by('e.first_name');
		$query	= $this->db->get();

		return $query->result_array();
	}
}
