<?php
	$this->load->view("header");
	$this->load->view("topnavbar");
	$this->load->view("leftshortcut");
?>
<div id="container" class="out-container">
	<div class="row">
		<div class="col-lg-12">
			<h4><?php echo lang('CREATE_NEW_PROJECT'); ?></h4>
			<div class="grid-box" id="taskstatuscontainer">
			</div>
		</div>
	</div>
	<div class="row" id="createproject">
		<div class="col-lg-12">
			<form class="form-horizontal">
				<div class="control-group">
					<select name="client_id" id="client_id" data-bind="options:clients,optionsText: 'first_name', optionsValue: 'client_id', value: client_id" data-placeholder="Choose a client...">
					</select>
				</div>
				<div class="control-group">
					<input type="text" name="name" id="name" class="col-lg-8" placeholder="Project Name" data-bind="value:name" />
				</div>
				<div class="control-group">
					<input type="text" name="code" id="code" placeholder="Project Code" data-bind="value:code" maxlength="6"/>
				</div>
				<div class="control-group">
					<h4><?php echo lang('INVOICE'); ?></h4>
				</div>
				<div class="control-group">
					<label class="radio"><input type="radio" name="is_billable" id="is_billable" /><?php echo lang('THIS_PROJECT_IS_NOT_BILLABLE'); ?></label>
				</div>
				<div class="control-group">
					<div class="pull-left">
					<label class="radio"><input type="radio" name="is_billable" id="is_billable" /><?php echo lang('THIS_PROJECT_IS_BILLABLE_WE_INVOICE_BY'); ?></label>
					</div><div class="pull-left" style="margin-left:5px">
					<select name="project_invoice_method_id" id="project_invoice_method_id" data-bind="options:project_invoice_methods,optionsText: 'name', optionsValue: 'project_invoice_method_id', value: project_invoice_method_id" data-placeholder="Choose a invoice method...">
					</select></div><div class="clearfix"></div>
				</div>
				<div class="control-group">
					<h4><?php echo lang('BUDGET'); ?></h4>
				</div>
				<div class="control-group">
					<div class="pull-left">
					<select name="project_budget_type_id" id="project_budget_type_id" data-bind="options:project_budget_types,optionsText: 'name', optionsValue: 'project_budget_type_id', value: project_budget_type_id" data-placeholder="Choose a project budget type...">
					</select>
					</div><div class="pull-left" style="margin-left:5px;">
						<input type="text" name="hours" id="hours" placeholder="Hours" class="input-mini" />
					</div><div class="clearfix"></div>
				</div>
				<div class="control-group">
					<label class="checkbox"><input type="checkbox" name="is_show_budget_report" id="is_show_budget_report" /><?php echo lang('SHOW_REPORT_TO_ALL_EMP'); ?></label>
				</div>
				<div class="control-group">
					<div class="pull-left">
						<label class="checkbox"><input type="checkbox" name="is_send_email" id="is_send_email" /><?php echo lang('EMAIL_ALERT_ON_PROJECT_REACHES'); ?></label>
					</div><div class="pull-left" style="margin-left:5px;">
						<input type="text" name="percentage" id="percentage" placeholder="%" class="input-mini" />&nbsp;%
					</div><div class="clearfix"></div>
				</div>
				<div class="control-group">
					<textarea name="description" id="description" rows="5" cols="5" class="col-lg-8" placeholder="Notes"></textarea>
				</div>
				<div class="control-group">
					<button type="submit" class="btn btn-primary" data-bind="text:createbtnlbl, click:create"></button>&nbsp;&nbsp;&nbsp;
					<button type="submit" class="btn btn-danger"><?php echo lang('CANCEL'); ?></button>
				</div>
			</form>
		</div>
	</div>
</div>
<?php $this->load->view("rightshortcut");?>
<?php $this->load->view("script");?>
<?php 
javascript("assets/js/createproject.js");
?>
<script>
var _clients = <?php echo json_encode($clients); ?>;
var _project_invoice_methods = <?php echo json_encode($project_invoice_methods); ?>;
var _project_budget_types = <?php echo json_encode($project_budget_types); ?>;
var _project = <?php echo json_encode($project); ?>;
$(function () {
	var $createproject = $("#createproject");
	var createProject = new CreateProject();
	createProject.clients.push({ "client_id": "", "first_name": ""});
	$.each(_clients,function(i,client){
		createProject.clients.push(client);
	});
	createProject.clients.push({ "client_id": "-1", "first_name": "--Add New Client--"});
	$.each(_project_invoice_methods,function(i,item){
		createProject.project_invoice_methods.push(item);
	});
	$.each(_project_budget_types,function(i,item){
		createProject.project_budget_types.push(item);
	});
	ko.applyBindings(createProject, $createproject.get(0));
	$("select").trigger("liszt:updated");
});
</script>
